clear;

constrainttype = 3; % 1-3

load("cook.mat");

k = 1; % first order VEM for elasticity
ndim = 2;

E = 200000; nu = 0.3; % plane stress
mat.E = E; mat.nu = nu;

sumNode = size(node,1);

p = 100; % press

nodeL = find(node(:,1)<0.001);
sL = size(nodeL,1);
nodeR  = find(node(:,1)>48-0.001);
% find face by node
pface = findFace(node,elem,nodeR);
press = [pface,ones(length(pface),1)*p];
fixNode = [nodeL,ones(sL,1),zeros(sL,1);nodeL,2*ones(sL,1),zeros(sL,1)];
fixMes = [fixNode(:,1)+(fixNode(:,2)-1)*sumNode,fixNode(:,3)];

auxT = auxstructure(node,elem);

nodeForce = getForce(node,sumNode,sumNode,elem,auxT,1,press,'y');


% global stiffness matrix

GK = globalK(node,elem,ndim,mat,constrainttype);


[GK,F] = boundaryCondition(GK,nodeForce,fixMes(:,1),fixMes(:,2),1);

uh = GK\F;

uh = full(uh);

ux = uh(1:sumNode);
uy = uh(sumNode+1:end);


% stress
[stress,mises] = calculateStress(node,elem,uh,mat);

figure;
showsolution(node+[ux,uy],elem,mises);
figure;
showsolution(node+[ux,uy],elem,ux);



